;Ŀ
;  Motzel's Protected Mode DOS-extender                                     
;                                                                           
;  Small 3d engine header                                                   
;                                                                           
;  Author       : Bogdan Modzelewski a.k.a Motzel of Cryogen^Suspend        
;  File created : 10.04.98                                                  
;

;Ŀ
; Structures declaration                                                    
;
 world3d_size   equ 110
 world3d        struc
  num_obj       dw ?
  cam_pos_x     dd ?
  cam_pos_y     dd ?
  cam_pos_z     dd ?
  cam_tgt_x     dd ?
  cam_tgt_y     dd ?
  cam_tgt_z     dd ?
  cam_direction dd ?, ?, ?
  cam_roll      dd ?
  cam_mtx       dd 16 dup (?)
  objects       dd ?
 world3d        ends

 object_size    equ 116
 object         struc
  obj_pos_x     dd ?
  obj_pos_y     dd ?
  obj_pos_z     dd ?
  obj_ang_x     dd ?
  obj_ang_y     dd ?
  obj_ang_z     dd ?
  obj_num_verts dw ?
  obj_num_faces dw ?
  obj_verts     dd ?
  obj_verts_rot dd ?
  obj_norm      dd ?
  obj_norm_rot  dd ?
  obj_vertex2d  dd ?
  obj_faces     dd ?
  obj_mtx       dd 16 dup(?)
 object         ends

 camera_size    equ 104
 camera         struc
  c_pos_x       dd ?
  c_pos_y       dd ?
  c_pos_z       dd ?
  c_tgt_x       dd ?
  c_tgt_y       dd ?
  c_tgt_z       dd ?
  c_dir_x       dd ?
  c_dir_y       dd ?
  c_dir_z       dd ?
  c_roll        dd ?
  c_mtx         dd 16 dup(?)
 camera         ends

 triangle_size  equ 23
 triangle       struc
  t_texture     dd ?
  t_normal      dd ?, ?, ?
  t_p1          dw ?
  t_p2          dw ?
  t_p3          dw ?
  t_type        db ?
 triangle       ends

 vec_size       equ 12
 vector         struc
  vec_x         dd ?
  vec_y         dd ?
  vec_z         dd ?
 vector         ends

 vert2d_size     equ 28
 vert2d          struc
  vert_x         dd ?
  vert_y         dd ?
  vert_z         dd ?
  vert_u         dd ?
  vert_v         dd ?
  vert_envx      dd ?
  vert_envy      dd ?
 vert2d          ends

;Ŀ
; Constants declarations                                                    
;
 TEXT_FACE       equ 1
 ENV_FACE        equ 2

;Ŀ
; Library functions and variables                                           
;
 global m3d_TextTri32ZB_:near, m3d_TranspTextTri32ZB_:near

 global VectorDot_:near, VectorCross_:near, VectorLength_:near
 global VectorCreate_:near, VectorNormalize_:near
 global MatrixCopy_:near, MakePerspective_:near, MatrixMultiply_:near
 global MatrixIdentity_:near, MatrixRotateXYZ_:near, MatrixCopy_:near
 global CalcObjectMatrix_:near, CalcCameraMatrix_:near
 global TransformPoints_:near, SetObjectSkin_:near, SetObjectType_:near
 global CalcObjectNormals_:near
 global RenderWorld_:near, SetupWorldData_:near

 global _WorldData1:near, _WorldData1_size:dword
; global _WorldData2:near, _WorldData2_size:dword
 global _WorldData3:near, _WorldData3_size:dword
 global _WorldData4:near,Lights_scene4:near, _WorldData4_size:dword
; global _WorldData4:near, _WorldData4_size:dword
 global _WorldData5:near,Lights_scene5:near, _WorldData5_size:dword
 global _WorldData6:near, _WorldData6_size:dword

 global _pYLookUp:dword
 global _mdeClipMinX:dword, _mdeClipMaxX:dword
 global _mdeClipMinY:dword, _mdeClipMaxY:dword
 global _m3d_ZFrame:word
