AddTxtLightRGB  proc
                pushad
                mov    d [__PRZES_Y_RGB],ebx
                mov    d [__PRZES_X_RGB],eax
                mov    ebp,64
LTxtY_RGB:
                mov    ecx,64
LTxtX_RGB:

                mov    ebx,ebp
                add    ebx,12345678h
                __PRZES_Y_RGB=$-4
                shl    ebx,8
                add    ebx,ecx
                add    ebx,12345678h
                __PRZES_X_RGB=$-4
                and    ebx,0FFFFh
                shl    ebx,2

                mov    al,[esi]

                mov    dl,[edi+ebx+0]
                add    dl,al
                jnc    RGB1_OK
                mov    dl,255
RGB1_OK:
                mov    [edi+ebx+0],dl


                mov    dl,[edi+ebx+1]
                add    dl,al
                jnc    RGB2_OK
                mov    dl,255
RGB2_OK:
                mov    [edi+ebx+1],dl


                mov    dl,[edi+ebx+2]
                add    dl,al
                jnc    RGB3_OK
                mov    dl,255
RGB3_OK:
                mov    [edi+ebx+2],dl

                add    esi,1
                dec    ecx
                jnz    LTxtX_RGB
                dec    ebp
                jnz    LTxtY_RGB
                popad
                ret
AddTxtLightRGB  endp


AddTxtLightB    proc
                pushad
                mov    d [__PRZES_Y_B],ebx
                mov    d [__PRZES_X_B],eax
                mov    ebp,64
LTxtY_B:
                mov    ecx,64
LTxtX_B:

                mov    ebx,ebp
                add    ebx,12345678h
                __PRZES_Y_B=$-4
                shl    ebx,8
                add    ebx,ecx
                add    ebx,12345678h
                __PRZES_X_B=$-4
                and    ebx,0FFFFh
                shl    ebx,2

                mov    al,[esi]

                mov    dl,[edi+ebx+0]
                add    dl,al
                jnc    B1_OK
                mov    dl,255
B1_OK:
               mov    [edi+ebx+0],dl


                add    esi,1
                dec    ecx
                jnz    LTxtX_B
                dec    ebp
                jnz    LTxtY_B
                popad
                ret
AddTxtLightB    endp


AddTxtLightG    proc
                pushad
                mov    d [__PRZES_Y_G],ebx
                mov    d [__PRZES_X_G],eax
                mov    ebp,64
LTxtY_G:
                mov    ecx,64
LTxtX_G:

                mov    ebx,ebp
                add    ebx,12345678h
                __PRZES_Y_G=$-4
                shl    ebx,8
                add    ebx,ecx
                add    ebx,12345678h
                __PRZES_X_G=$-4
                and    ebx,0FFFFh
                shl    ebx,2

                mov    al,[esi]

                mov    dl,[edi+ebx+1]
                add    dl,al
                jnc    G1_OK
                mov    dl,255
G1_OK:
                mov    [edi+ebx+1],dl


                add    esi,1
                dec    ecx
                jnz    LTxtX_G
                dec    ebp
                jnz    LTxtY_G
                popad
                ret
AddTxtLightG    endp


AddTxtLightR    proc
                pushad
                mov    d [__PRZES_Y_R],ebx
                mov    d [__PRZES_X_R],eax
                mov    ebp,64
LTxtY_R:
                mov    ecx,64
LTxtX_R:

                mov    ebx,ebp
                add    ebx,12345678h
                __PRZES_Y_R=$-4
                shl    ebx,8
                add    ebx,ecx
                add    ebx,12345678h
                __PRZES_X_R=$-4
                and    ebx,0FFFFh
                shl    ebx,2

                mov    al,[esi]

                mov    dl,[edi+ebx+2]
                add    dl,al
                jnc    R1_OK
                mov    dl,255
R1_OK:
               mov    [edi+ebx+2],dl


                add    esi,1
                dec    ecx
                jnz    LTxtX_R
                dec    ebp
                jnz    LTxtY_R
                popad
                ret
AddTxtLightR    endp






MoveTxtLights proc

              fild  licznik
              mov   temp,297
              fidiv temp
              fcos
              mov   temp,490
              fimul temp
              mov   temp,18
              fiadd temp
              fistp LightY1

              fild  licznik
              mov   temp,197
              fidiv temp
              fsin
              mov   temp,190
              fimul temp
              mov   temp,33
              fiadd temp
              fistp LightX1

              fild  licznik
              mov   temp,137
              fidiv temp
              fcos
              mov   temp,130
              fimul temp
              mov   temp,133
              fiadd temp
              fistp LightY2

              fild  licznik
              mov   temp,477
              fidiv temp
              fsin
              mov   temp,253
              fimul temp
              mov   temp,344
              fiadd temp
              fistp LightX2

              fild  licznik
              mov   temp,437
              fidiv temp
              fcos
              mov   temp,430
              fimul temp
              mov   temp,573
              fiadd temp
              fistp LightY3

              fild  licznik
              mov   temp,577
              fidiv temp
              fsin
              mov   temp,853
              fimul temp
              mov   temp,123
              fiadd temp
              fistp LightX3

              fild  licznik
              mov   temp,333
              fidiv temp
              fcos
              mov   temp,444
              fimul temp
              mov   temp,085
              fiadd temp
              fistp LightY4

              fild  licznik
              mov   temp,411
              fidiv temp
              fsin
              mov   temp,661
              fimul temp
              mov   temp,321
              fiadd temp
              fistp LightX4

              fild  licznik
              mov   temp,413
              fidiv temp
              fcos
              mov   temp,344
              fimul temp
              mov   temp,285
              fiadd temp
              fistp LightY5

              fild  licznik
              mov   temp,345
              fidiv temp
              fsin
              mov   temp,761
              fimul temp
              mov   temp,1
              fiadd temp
              fistp LightX5

              ret

LightX1       dd 128
LightY1       dd 128
LightX2       dd 128
LightY2       dd 128
LightX3       dd 128
LightY3       dd 128
LightX4       dd 128
LightY4       dd 128
LightX5       dd 128
LightY5       dd 128
MoveTxtLights endp


;*****************************************************************************
; Draws scaled light in _virtual_screen 32bit
; In:
;   EAX - x position of left upper corner
;   EDX - y position of left upper corner
;   EBX - size of light in pixels
;   ECX - pointer to envmap (256x256x32bit)
;   Stos : Light_Z (32bit FLOAT)
; Out:
;   none
;*****************************************************************************
m3d_DrawLight32_:

    push    ebx
    shr     ebx,1
    sub     eax,ebx
    sub     edx,ebx
    pop     ebx

    fld     dword ptr [One]
    fdiv    dword ptr [esp+4]

    pushad

    fmul    dword ptr [Scale20]
    fistp   dword ptr [blabla]
    xor     esi, esi
    mov     si, word ptr [_m3d_ZFrame]
    shl     esi,16 ;20
    mov     ebp, [blabla]
    and     ebp,0ffffh ;0fffffh
    or      esi, ebp
    mov     dword ptr [dl_selfmod], esi

    ; sprawdzenie czy wielkosc > 0
    cmp     ebx, 0
    jle     dl_wyjscie

    mov     [ poz_y], 0
    mov     [l_width], ebx
    mov     [l_height], ebx
    mov     esi, ecx
    mov     ebp, eax
    mov     ecx, edx


    ; sprawdzenie czy swiatlo jest cale poza ekranem
    cmp     eax, [_mdeClipMaxX]
    jg      dl_wyjscie

    add     eax, ebx                ; eax = x + width

    cmp     edx, [_mdeClipMaxY]
    jg      dl_wyjscie

    add     edx, ebx                ; edx = y + height

    cmp     eax, [_mdeClipMinX]
    jl      dl_wyjscie

    cmp     edx, [_mdeClipMinY]
    jl      dl_wyjscie


    mov     eax, 256*256            ;\
    xor     edx, edx                ; obliczenie delty
    div     ebx                     ;
    mov     delta, eax              ;/

    ; ** przechodzimy do clippingu swiatelka **
    mov     eax, ebp
    mov     edx, ecx
    add     eax, ebx
    add     edx, ebx

    ; clipping wspolrzednej X (z prawej)
    cmp     eax, [_mdeClipMaxX]
    jle     dl_ok_z_prawej
    mov     eax, [_mdeClipMaxX]
    sub     eax, ebp
    inc     eax
    mov     [l_width], eax
 dl_ok_z_prawej:

    ; clipping wspolrzednej Y (na dole)
    cmp     edx, [_mdeClipMaxY]
    jle     dl_ok_na_dole
    mov     edx, [_mdeClipMaxY]
    sub     edx, ecx
    inc     edx
    mov     [l_height], edx
 dl_ok_na_dole:

    mov     edx, ecx

    ; clipping wspolrzednej Y (na gorze)
    cmp     edx, [_mdeClipMinY]
    jge     dl_ok_na_gorze
    neg     ecx
    add     ecx, [_mdeClipMinY]
    sub     [l_height], ecx
    mov     eax, [delta]
    mul     ecx
    mov     byte ptr [ poz_y], al
    and     eax, 0ff00h
    shl     eax, 2
    add     esi, eax
    mov     ecx, [_mdeClipMinY]
 dl_ok_na_gorze:

    mov     eax, ebp

    ; clipping wspolrzednej X (po lewej)
    cmp     eax, [_mdeClipMinX]
    jge     dl_ok_po_lewej
    neg     ebp
    add     ebp, [_mdeClipMinX]
    sub     [l_width], ebp
    mov     eax, [delta]
    mul     ebp
    mov     byte ptr [init_l], al
    and     eax, 0ff00h
    sar     eax, (8-2)
    add     esi, eax
    mov     ebp, [_mdeClipMinX]
 dl_ok_po_lewej:

    cmp     [l_width], 0
    je      dl_wyjscie
    cmp     [l_height], 0
    je      dl_wyjscie

    ; przesuniecie do pozycji (x,y) na virtual screenie
    mov     edi, _pYLookUp
    shl     ebp, 2
    shl     ecx, 2
    add     ebp, [edi + ecx]

    mov     edi, offset UInt        ;\
    mov     eax, delta              ;
    and     eax, 0ff00h             ;
    sar     eax, (8-2)              ; inicjalizacja tablicy UInt
    mov     ecx, eax                ;
    shl     ecx, 8                  ; tutaj zmienic przy zmianie wielkosci
    mov     [edi], eax              ;
    add     eax, 4                  ;
    mov     [edi-4], eax            ;/

    mov     dl, byte ptr delta
    mov     eax, 320
    mov     add_y, dl
    sub     eax, l_width
    mov     add256, ecx
    shl     eax, 2
    mov     add320, eax

    add     ebp, _mdeVirtualScreen
 dl_outer:
    push    esi
    mov     bl, byte ptr delta
    mov     bh, init_l
    mov     edi, l_width
 dl_inner:
    mov     eax, 12345678h
    dl_selfmod = $ - 4
    cmp     eax, [ebp + 320*200*4]
    jb      dl_bez_wpisu

    mov     eax, [esi]
    mov     edx, [ebp]
    ror     eax, 8
    mov     ecx, edx
    ror     edx, 8
    add     al, dl
    jnc     g_prze
    mov     al, 255
 g_prze:
    add     ah, dh
    jnc     r_prze
    mov     ah, 255
r_prze:
    rol     eax, 8
;    add     bh, bl
;    sbb     edx, edx
    add     al, cl
    jnc     b_prze
    mov     al, 255
 b_prze:
    mov     [ebp], eax

dl_bez_wpisu:
    add     bh, bl
    sbb     edx, edx

    add     esi, [offset UInt + edx*4]
    add     ebp, 4
    dec     edi
    jnz     dl_inner

    add     ebp, add320
    pop     esi
    add     esi, add256
    mov     al,  poz_y
    add     al, add_y
    mov      poz_y, al
    jnc     dl_bez_prze
    add     esi, 256*4
 dl_bez_prze:
    dec     l_height
    jnz     dl_outer

 dl_wyjscie:
    popad
    ret     4

;  extrn  _mdeVirtualScreen:DWORD, _pYLookUp:DWORD
;  extrn  _mdeClipMinX:DWORD, _mdeClipMaxX:DWORD
;  extrn  _mdeClipMinY:DWORD, _mdeClipMaxY:DWORD
;  extrn  _m3d_ZFrame:WORD

  l_height       dd 0    ; wysokosc do rysowania
  l_width        dd 0    ; szerokosc do rysowania
  add320         dd 0    ; ile dodawac przy przejsciu do nast. linii do virt
  add256         dd 0    ; ile dodawac przy przejsciu do nast. linii do texture
  delta          dd 0
  poz_y          db 0    ; czesc ulamkowa delty pionowej
  add_y          db 0    ; adder delty pionowej (czesc ulamkowa)
  init_l         db 0    ; przy clippingu czesc ulamkowa poczatku (poziom)

                 dd 0    ; jest przeniesienie na czesci ulamkowej (poziom)
  UInt           dd 0    ; nie ma przeniesienia na czesci ulamkowej (poziom)

  Scale20        dd 65536.0 ;1048576.0
  blabla         dd 0
  One            dd 1.0
