; eax <- nr ascii literki do wypisania
; ebx <- X literki
; ecx <- Y literki
WriteChar     proc
              mov   esi,cadFoNT
              mov   edi,_mdeVirtualScreen

              sub   eax,65
              and   eax,0FFh
              mov   edx,eax
              shl   eax,6
              shl   edx,2
              add   eax,edx
              add   esi,eax ;     add   esi,17*5*4 ;6+2

              mov   edx,ecx
              shl   edx,10
              shl   ecx,8
              add   ecx,edx
              shl   ebx,2
              add   ecx,ebx
              add   edi,ecx

              mov   ebp,16
WriteCharY:
              mov   ecx,17
WriteCharX:
              mov   eax,[esi]
              mov   [edi],eax
              add   esi,4
              add   edi,4
              loop  WriteCharX

              add   edi,(320*4)-(17*4)
              add   esi,(441*4)-(16*4)
              dec   ebp
              jnz   WriteCharY
              ret
WriteChar     endp

; eax <- nr ascii literki do wypisania
; ebx <- X literki
; ecx <- Y literki
WriteCharADD  proc
              pushad
              mov   esi,cadFoNT
;              mov   edi,_mdeVirtualScreen

              sub   eax,65
              and   eax,0FFh
              mov   edx,eax
              shl   eax,6
              shl   edx,2
              add   eax,edx
              add   esi,eax ;     add   esi,17*5*4 ;6+2

              mov   edx,ecx
              shl   edx,10
              shl   ecx,8
              add   ecx,edx
              shl   ebx,2
              add   ecx,ebx
              add   edi,ecx

              mov   ebp,16
WriteCharYADD:
              mov   ecx,17
WriteCharXADD:
              mov   eax,[esi]
              mov   ebx,[edi]

              add   bl,al
              jnc   chradd1ok
              mov   bl,255
chradd1ok:

              add   bh,ah
              jnc   chradd2ok
              mov   bh,255
chradd2ok:
              ror   eax,16
              ror   ebx,16

              add   bl,al
              jnc   chradd3ok
              mov   bl,255
chradd3ok:
              rol   ebx,16
              mov   [edi],ebx

              add   esi,4
              add   edi,4
              loop  WriteCharXADD

              add   edi,(320*4)-(17*4)
              add   esi,(442*4)-(17*4)
              dec   ebp
              jnz   WriteCharYADD
              popad
              ret
WriteCharADD  endp


; eax <- nr ascii literki do wypisania
; ebx <- X literki
; ecx <- Y literki
WriteCharADD_big  proc
              pushad
              mov   esi,cadFoNTbig
;             mov   edi,_mdeVirtualScreen

              sub   eax,65
              and   eax,0FFh
              mov   edx,eax
              shl   eax,6
              shl   edx,2
              add   eax,edx
              shl   eax,1
              add   esi,eax ;     add   esi,17*5*4 ;6+2

              mov   edx,ecx
              shl   edx,10
              shl   ecx,8
              add   ecx,edx
              shl   ebx,2
              add   ecx,ebx
              add   edi,ecx

              mov   ebp,16*2
WriteCharYADD_big:
              mov   ecx,17*2
WriteCharXADD_big:
              mov   eax,[esi]
              mov   ebx,[edi]

              add   bl,al
              jnc   chradd1ok_big
              mov   bl,255
chradd1ok_big:

              add   bh,ah
              jnc   chradd2ok_big
              mov   bh,255
chradd2ok_big:
              ror   eax,16
              ror   ebx,16

              add   bl,al
              jnc   chradd3ok_big
              mov   bl,255
chradd3ok_big:
              rol   ebx,16
              mov   [edi],ebx

              add   esi,4
              add   edi,4
              loop  WriteCharXADD_big

              add   edi,(320*4)-(17*4*2)
              add   esi,(442*4*2)-(17*4*2)
              dec   ebp
              jnz   WriteCharYADD_big
              popad
              ret
WriteCharADD_big  endp

BZOOM         PROC
              PUSHAD
              mov   eax,TimerVal2
              mov   step_,eax
              shr   step_,1
              shl   step_,1
              mov   eax,step_
              shr   eax,1
              mov   _1_2step_,eax
              mov   edi,Temp_seg1

              xor   ecx,ecx
BluroZoomY:
              push  ecx
              mov   ecx,0 ;320       ; X max
BluroZoomX:
              mov   ebp,_1_2step_ ;-30  ;-1/2step ;ebp
              neg   ebp
              xor   eax,eax
              xor   ebx,ebx
BluroZoomI:
              mov   edx,ecx
              sub   edx,_1_2step_
              add   edx,ebp
              cmp   edx,319
              jge    dont_do_this
              cmp   edx,1
              jle   dont_do_this
              mov   bl,[esi+ebp]
              add   eax,ebx
dont_do_this:
              inc   ebp
              cmp   ebp,_1_2step_ ;30 ;step_ ;60   ;1/2 step  ;60  ; step
              jle   BluroZoomI

              push  edx
              xor   edx,edx
              mov   ebx,step_  ;60+1 ;step +1
              inc   ebx
              div   ebx
              pop   edx

              mov   ah,al
              mov   [edi],ax
              mov   [edi+2],al
              add   esi,4
              add   edi,4
              inc   ecx
              cmp   ecx,320
              jb    BluroZoomX

              pop   ecx
              inc   ecx
              cmp   ecx,16 ;20 ;67     ; Y max
              jb    BluroZoomY

;: bllllllllloooooooooooooooooooooooooorrrrrrrrrro zoooooooooooooom
              POPAD
              RET
BZOOM         ENDP

SHOWADD320    PROC
              PUSHAD
              mov   ecx,320*16*4
showlgo:
              xor   eax,eax
              xor   ebx,ebx

              mov   al,[esi]
              mov   bl,[edi]
              add   eax,ebx
              cmp   eax,255
              jna   jklsdf
              mov   eax,255
jklsdf:
              mov   [edi],al
              add   edi,1
              add   esi,1
              loop  showlgo
              POPAD
              RET
SHOWADD320    ENDP


clear_ve      proc
              pushad
              mov     edi,_mdeVirtualScreen
              xor     eax,eax
              mov     ecx,320*200
              rep     stosd
              popad
              ret
clear_ve      endp



; eax <- nr ascii literki do wypisania
; ebx <- X literki
; ecx <- Y literki
TWriteCharADD  proc
              pushad
              mov   esi,cadFoNT
;              mov   edi,_mdeVirtualScreen

              sub   eax,65
              and   eax,0FFh
              mov   edx,eax
              shl   eax,6
              shl   edx,2
              add   eax,edx
              add   esi,eax ;     add   esi,17*5*4 ;6+2

;              mov   edx,ecx
;              shl   edx,10
              shl   ecx,10
;              add   ecx,edx
              shl   ebx,2
              add   ecx,ebx
              add   edi,ecx

              mov   ebp,16
TWriteCharYADD:
              mov   ecx,17
TWriteCharXADD:
              mov   eax,[esi]
              mov   ebx,[edi]

              add   bl,al
              jnc   Tchradd1ok
              mov   bl,255
Tchradd1ok:

              add   bh,ah
              jnc   Tchradd2ok
              mov   bh,255
Tchradd2ok:
              ror   eax,16
              ror   ebx,16

              add   bl,al
              jnc   Tchradd3ok
              mov   bl,255
Tchradd3ok:
              rol   ebx,16
              mov   [edi],ebx

              add   esi,4
              add   edi,4
              loop  TWriteCharXADD

              add   edi,(256*4)-(17*4)
              add   esi,(442*4)-(17*4)
              dec   ebp
              jnz   TWriteCharYADD
              popad
              ret
TWriteCharADD  endp

;              mov   edi,TXT3
;              mov   ebx,120 ;X
;              mov   ecx,120 ;Y

TWriteTXT     proc
              pushad
              xor   ebp,ebp
              mov   edx,ebx
p_tAgin:
              push  edx

              mov   ebx,19
              mov   eax,ebp
              xor   edx,edx
              mul   ebx
              pop   edx

              add   eax,edx
              mov   ebx,eax

              xor   eax,eax
              mov   al,[esi+ebp]
              cmp   al,0
              je    koniec_tp

              call  TWriteCharADD

              inc   ebp
              jmp  p_tAgin
koniec_tp:
              popad
              ret
TWriteTXT     endp

              mov   eax,'B'
              mov   ebx,0+19*1
              mov   ecx,120
              call  TWriteCharADD

              mov   eax,'C'
              mov   ebx,0+19*2
              mov   ecx,120
              call  TWriteCharADD

              mov   eax,'D'
              mov   ebx,0+19*3
              mov   ecx,120
              call  TWriteCharADD

              mov   eax,'E'
              mov   ebx,0+19*4
              mov   ecx,120
              call  TWriteCharADD

              mov   eax,'F'
              mov   ebx,0+19*5
              mov   ecx,120
              call  TWriteCharADD

              mov   eax,'G'
              mov   ebx,0+19*6
              mov   ecx,120
              call  TWriteCharADD

              mov   eax,'H'
              mov   ebx,0+19*7
              mov   ecx,120
              call  TWriteCharADD

              mov   eax,'I'
              mov   ebx,0+19*8
              mov   ecx,120
              call  TWriteCharADD

