;Ŀ
; Name: mpd32bitTo16bit        Trashed regs: None                          
;Ĵ
; Description: Converts and copies 32bit virtual screen to 15/16bit screen. 
;Ĵ
; In   : None                                                               
; Out  : None                                                               
;
mpdConvert32to16:
        pushad

        mov     al, _mpdBPP
        cmp     al, 16
        jnz     nie16
        mov     al, 2
        jmp     sp16dal
nie16:  mov     al, 3
sp16dal:
        mov     b [sm3_bits], al
        mov     b [sm4_bits], al

        mov     al, _mpdVbeRShift
        mov     b [sm1_r_shift], al
        mov     b [sm2_r_shift], al

        mov     al, _mpdVbeGShift
        mov     b [sm1_g_shift], al
        mov     b [sm2_g_shift], al

        mov     al, _mpdVbeBShift
        mov     byte ptr [sm1_b_shift], al
        mov     byte ptr [sm2_b_shift], al

        mov     edi, _mpdLfbAddress
        mov     esi,v_e ; _mpdVirtualScreen
        sub     edi, 4

        mov     ecx, 200
sp16l_pety:
        mov     ebp, 160
sp16l_petx:
        ; pierwszy pixel
        mov     al, [esi + 2]
        mov     bl, [esi + 1]
        mov     dl, [esi    ]

        and     eax, 0ffh
        and     ebx, 0ffh
        add     esi, 4

        shr     eax, 3
        shl     eax, 11
        sm1_r_shift = $ - 1

        shr     ebx, 2
        sm3_bits = $ -1
        shl     ebx, 5
        sm1_g_shift = $ - 1

        and     edx, 0ffh
        or      eax, ebx

        shr     edx, 3
        shl     edx, 0
        sm1_b_shift = $ - 1

        or      eax, edx

        rol     eax, 16

        ; drugi pixel
        mov     al, [esi + 2]
        mov     bl, [esi + 1]
        mov     dl, [esi    ]

        and     eax, 0ffff00ffh
        and     ebx, 0ffh
        add     esi, 4

        shr     ax, 3
        shl     ax, 11
        sm2_r_shift = $ - 1

        shr     ebx, 2
        sm4_bits = $ - 1
        shl     ebx, 5
        sm2_g_shift = $ - 1

        and     edx, 0ffh
        or      eax, ebx

        shr     edx, 3
        shl     edx, 0
        sm2_b_shift = $ - 1

        add     edi, 4
        or      eax, edx

        ror     eax, 16
        mov     [edi], eax

        dec     ebp
        jnz     sp16l_petx

        dec     ecx
        jnz     sp16l_pety

        popad
        ret
