;Ŀ
;  "C O M E  O N"   Intro 64k                                               
;                                                                           
;  Code         : Wojciech Przybysz  a.k.a Mancer of Cryogen                
;               : Bogdan Modzelewski a.k.a Motzel of Cryogen^Suspend        
;                                                                           
;  File created : 11.01.99                                                  
;

JUMPS
.486p
.487

txtX_cMa equ 50
txtY_cM equ 0


;Ŀ
; Program code                                                              
;
Code32 Segment Para Public Use32 'Code'
Assume CS:Code32, DS:Code32, ES:Code32
global _NEAR_CLIP:dword

;Ŀ
; Includy                                                                   
;

include !libs\mpd\mpd.inc
include !libs\vesa\mpd_vesa.inc
;include !libs\vesa\mpd32_16.inc
include !libs\mxm\mxm.inc
include !libs\engine\engine.inc
include !libs\fdir\freedir.inc

ZapiszMarker:
 pushad
 Init_DS_DX plik
 mov     [rm_regs.rm_EAX], 3c00h ; ah = 3ch
 mov     [rm_regs.rm_ECX], 0110b ; ecx = 0110b
 mov     ebx, 21h                ; int 21h
 mov     eax, 0300h              ; wykonaj rmode int
 mov     edi, o rm_regs
 xor     ecx, ecx
 int     31h                     ; go !
 mov     eax, [rm_regs.rm_EAX]
 mov     handle, ax
 popad
 ret

 UsunMarker:
 pushad
 ; zamykamy plik
 mov     [rm_regs.rm_EAX], 3e00h ; ah = 3eh
 xor     ebx, ebx
 mov     bx, handle
 mov     [rm_regs.rm_EBX], ebx
 mov     ebx, 21h                ; int 21h
 mov     eax, 0300h              ; wykonaj rmode int
 mov     edi, o rm_regs
 xor     ecx, ecx
 int     31h                     ; go !

 ; usuwamy plik
 Init_DS_DX plik
 mov     [rm_regs.rm_EAX], 4100h ; ah = 41h
 mov     ebx, 21h                ; int 21h
 mov     eax, 0300h              ; wykonaj rmode int
 mov     edi, o rm_regs
 xor     ecx, ecx
 int     31h                     ; go !
 popad
 ret

Start32:
;             Start
        finit

        Init_DS_DX Hello_msg
        call    mpdWrite32

        Init_DS_DX mem_msg
        call    mpdWrite32

         ;e1d480
        mov     eax,0501h
        mov     ecx,0d480h
        mov     ebx,00E1h;0140h               ; alokujemy 20 megsow (1400000h)
        int     31h
        jnc     ok_mem

        Init_DS_DX nomem_msg
        call    mpdWrite32
        jmp     mpdExit32
ok_mem:
        ; w bx:cx mamy adres fizyczny, obliczamy wzgledem Code32
        shl     ebx, 16
        mov     bx, cx
        sub     ebx, Code32Addr
        mov     [Big_B], ebx             ; addy - adres zaalokowanej pamieci

        ;czyscimy gowno
        mov     edi,ebx
        mov     ecx,0e1d480h/4
        xor     eax,eax
        rep     stosd

        ; przypisujemy adresy
        include !libs\givemem.inc

;Ŀ
;                              Precalsy                                     
;

         Init_DS_DX Precal_msg
         call    mpdWrite32

         call    CalculateSinCos      ;- Sinusy i cosinusy do Generatora
         call    CalculateUSin        ;/
         call    Calculate_sincos_gel ; do gelu

           ;  texturki
           mov    esi,o MiniEnv
           mov    edi,SFlare
           call   make_sflare

           Init_DS_DX temp_txt0
           call    mpdWrite32
           include  !txt\mtxt00.asm

           Init_DS_DX temp_txt1
           call    mpdWrite32
          include  !txt\mtxt01.asm

           Init_DS_DX temp_txt2
           call    mpdWrite32
          include  !txt\mtxt02.asm

           Init_DS_DX temp_txt3
           call    mpdWrite32
          include  !txt\mtxt03.asm

           Init_DS_DX temp_txt4
           call    mpdWrite32
          include  !txt\mtxt04.asm

           Init_DS_DX temp_txt5
           call    mpdWrite32
          include  !txt\mtxt05.asm

;           Init_DS_DX temp_txt6
;           call    mpdWrite32
;           include  !txt\mtxt06.asm

           Init_DS_DX temp_txt7
           call    mpdWrite32
           include  !txt\mtxt07.asm

;           Init_DS_DX temp_txt8
;           call    mpdWrite32
;           include  !txt\mtxt08.asm

;            Init_DS_DX temp_txt9
;            call    mpdWrite32
;            include  !txt\mtxt09.asm

;           Init_DS_DX temp_txt10
;           call    mpdWrite32
;           include  !txt\mtxt10.asm

           Init_DS_DX temp_txt11
           call    mpdWrite32
          include  !txt\mtxt11.asm

           Init_DS_DX temp_txt12
           call    mpdWrite32
          include  !txt\mtxt12.asm

           Init_DS_DX temp_txt13
           call    mpdWrite32
           include  !txt\mtxt13.asm

           Init_DS_DX temp_txt14
           call    mpdWrite32
           include  !txt\mtxt14.asm



           ;a teraz flary
           Init_DS_DX temp_flare1
           call    mpdWrite32
           include  !txt\mflr01.asm

           Init_DS_DX temp_flare2
           call    mpdWrite32
          include  !txt\mflr02.asm

           Init_DS_DX temp_flare3
           call    mpdWrite32
          include  !txt\mflr03.asm

           Init_DS_DX temp_flare4
           call    mpdWrite32
           include  !txt\mflr04.asm

           Init_DS_DX temp_flare5
           call    mpdWrite32
           include  !txt\mflr05.asm


;         ToonelZ

           Init_DS_DX temp_tunel1
           call    mpdWrite32
           mov     edi,tuneltab_0
           call    MakeTunnel_wired

           Init_DS_DX temp_tunel2
           call    mpdWrite32
           mov     eax,tuneltab_1
           mov     _o_sg_tab,eax
           call    MakeTunnelSG2

           Init_DS_DX temp_tunel3
           call    mpdWrite32
           mov     eax,tuneltab_2
           mov     _o_sg_tab,eax
           call    MakeTunnelSG1

           Init_DS_DX temp_tunel4
           call    mpdWrite32


          mov     edi,tuneltab_3
          mov     esi,tuneltab_2
          add     esi,640*399*2
          mov     ebp,400
flip1_Y:
          mov     ecx,640/2
          rep     movsd
          sub     esi,640*2*2
          dec     ebp
          jnz     flip1_Y


          mov     eax,shadetbl
          mov     _fd_shadetbl,eax

          mov     edi,bump_shade_tbl
          call    calc_shade_tbl

          mov     edi,envmap8
          call    Calculate_phongmap      ; generowanie phongmapy

;         Logosek
          include  !txt\mlogo.asm

;         Font
          include  !txt\mfont.asm

;         Napisy
          include !libs\do_text.inc

;         Picek Monique
           include !txt\mpic.asm

;         Picek Monique
           include !txt\mGREETZ.asm


;           3d engine stuph

          ; ustawiamy Ylookup

          mov   edi,_pYLookUp
          mov   ecx,1024
          xor   eax,eax
do_Ylookup:
          mov   [edi],eax
          add   eax,320*4
          add   edi,4
          loop  do_Ylookup


          ; Wczytujemy scenki, ustawiamy skiny, liczymy normalne ..
          include !libs\engine\setw1.asm ;crn
;          include !libs\engine\setw2.asm
          include !libs\engine\setw3.asm ; kostka
          include !libs\engine\setw4.asm ;torus
          include !libs\engine\setw5.asm ;scenka_big
          include !libs\engine\setw6.asm ;tryb

          call  MakeShadeTable_

          ;           Vesa stuph
;          call    mpdDetectVesa
;          Init_DS_DX vesaok_msg
;          call    mpdWrite32
;          jnc     ok_vesa
;          Init_DS_DX novesa_msg
;          call    mpdWrite32
;          jmp     mpdExit32
;ok_vesa:
;          mov     eax, o Mode2Set1
;          call    mpdVbeInitMode
;          jnc     ok_mode1
;;         call    mpdSetTextMode
;          Init_DS_DX nomode_msg
;          call    mpdWrite32
;          jmp     mpdExit32
;ok_mode1:
;
              mov     eax,v_e
              mov     _mdeVirtualScreen,eax


        ; sprawdzamy czy jest vesa i wypelniamy tabliczke z trybami
        call    mpdDetectVesa
        jnc     ok_vesa
        Init_DS_DX novesa_msg
        call    mpdWrite32
        jmp     mpdExit32
ok_vesa:

        ; ustawiamy tryb 320x200 15/16 bit
        mov     eax, o Mode2Set
        mov     w [eax + 2], 320
        mov     w [eax + 4], 200
        mov     w [eax + 6], 16
        call    mpdVbeInitMode
        jnc     ok_mode16

        ; nie udalo sie ustawic trybu 16bit, probujemy 15bit
        mov     w [eax + 6], 15
        call    mpdVbeInitMode
        jnc     ok_mode16
        Init_DS_DX nomode_msg
        call    mpdWrite32
        jmp     mpdExit32
ok_mode16:



              ; mxm stuph
              mov   edi, [EnvAddr]
              call  xmpGetGUSPort_
              mov   ebx, mxmdata
              mov   ecx,65536
              mov   esi, o module
              mov   dl , MXMINTMODEDPMI
              call  xmpInit_
              xor   eax, eax
              call  xmpPlay_
              call  ZapiszMarker



;                 PART  I
              include !libs\loops\loop1.asm
;                 PART  II
              include !libs\loops\loop2.asm
;                 PART  III
             include !libs\loops\loop3.asm
;                 PART  IV
              include !libs\loops\loop4.asm
;                 PART  V
              include !libs\loops\loop5.asm
;                 PART  VI
              include !libs\loops\loop6.asm
;                 PART  VII
              include !libs\loops\loop7.asm
;                 PART  VIII
              include !libs\loops\loop8.asm
;                 PART  IX
              include !libs\loops\loop9.asm


mainloop_X:

              mov    TimerVal,0

                ; ustawienie trybu tekstowego
              mov     [rm_regs.rm_EAX], 03h   ; al = 03h
              mov     ebx, 10h                ; int 10h
              mov     eax, 0300h              ; wykonaj rmode int
              mov     edi, o rm_regs
              xor     ecx, ecx
              int     31h                     ; Go !

mainloop_X_:

              mov     esi,o azki
              mov     edi,_b8000h ;0a000h
              mov     ecx,460*2   ;80*23
              rep     movsd


              cmp   TimerVal,80h
              ja    FINITO

              in    al,60h
              dec   al
              jnz   mainloop_X_

FINITO:
              call    xmpStop_
              call    UsunMarker
              jmp     mpdExit32



;Ŀ
;                                 Mesedze                                   
;

Hello_msg       db ' "C O M E  O N" v0.78',13,10,'$'
;novesa_msg      db ' ERROR: Vesa not detected !',13,10,'$'
vesaok_msg      db ' Vesa detected ',13,10,'$'
;nomode_msg      db ' ERROR: Setting mode 320x200x32bit !',13,10,'$'
mem_msg         db ' Allocating 15 MB',13,10,'$'
nomem_msg       db ' ERROR: no enough MEM ! :',39,'(',13,10,'$'
Precal_msg      db '',13,10,'$'

novesa_msg      db ' Vesa not detected !',13,10,'$'
nomode_msg      db ' Error setting mode 320 x 200 15/16bit !',13,10,'$'
Mode2Set        dw 0, 320, 200, 32

temp_txt0        db ' Textures: 1,','$'
temp_txt1        db '2,','$'
temp_txt2        db '3,','$'
temp_txt3        db '4,','$'
temp_txt4        db '5,','$'
temp_txt5        db '6,','$'
temp_txt7        db '7,','$'
temp_txt11       db '8,' ,'$'
temp_txt12       db '9,' ,'$'
temp_txt13       db '10,','$'
temp_txt14       db '11',13,10,'$'

;temp_txt6        db '','$'
;temp_txt8        db '',13,10,'$'
;temp_txt9        db '',13,10,'$'
;temp_txt10       db '',13,10,'$'


temp_flare1      db ' Flares: 1,','$'
temp_flare2      db '2,','$'
temp_flare3      db '3,','$'
temp_flare4      db '4,','$'
temp_flare5      db '5',13,10,'$'


temp_tunel1      db ' Other Stuph: 1,','$'
temp_tunel2      db '2,','$'
temp_tunel3      db '3','$'
temp_tunel4      db 13,10,' GFX ..',13,10,'$'
plik  db 'c:\crn_cmn.mrk', 0
handle dw 0

g1    db 'ALTAIR',0
g2    db 'ANAKATA',0
g3    db 'EXODUS',0
g4    db 'FLOV',0
g5    db 'INTERROR',0
g6    db 'KNIGHTS',0
g7    db 'KOROZONE',0
g8    db 'MIST',0
g9    db 'PLATOON',0
g10   db 'PL',0
g11   db 'COMP',0
g12   db 'DEMOSCENA',0
g13   db 'TATANKA',0

;Ŀ
;                                Data                                       
;
 dzie   dd 46
_dzie   dd 46.0

Mode2Set1       dw 0, 320, 200, 32
synchronizer    dd 0

_m3d_ZFrame  dw 0

adder           dd 0.16
adder2          dd 0.08
adder_ang_tor1  dd 0.03
adder_ang_tor2  dd 0.024

_128    dd 128.0
_127    dd 127.0

 dziel  dd 92
_dziel  dd 92.0


licznik dd 0
temp1   dd 0
step_   dd 0
_1_2step_   dd 0

include !libs\memdata.inc
include !libs\engine\add.inc
include !libs\txtgen\txtg_dat.asm
include !libs\zoomer\zoomer.asm
include !libs\misc\misc.asm
include !libs\toonelz\toonelz.asm
include !libs\toonelz\sg1.asm
include !libs\toonelz\sg2.asm
include !libs\gel\sincos.asm
include !libs\gel\gel.asm
;include !libs\linez\linez.asm
include !libs\bump\bump.asm
include gfx\666.inc
include !libs\lights\lights.asm
include !libs\txtgen\txtgen.asm

cad_fnt: include gfx\compfnt.inc

logosek: include gfx\come.inc
logosek_pal: include gfx\come.pal

include gfx\monique.inc
include  msx\msx.inc


adder_z         dd 10.0
adderZ_scene3   dd  1.0
adder_ang_S3_1  dd 0.12
adder_ang_S3_2  dd 0.074
adder_ang_S3_3  dd 0.094

Z_scene3        dd  9.0
adder_roll      dd 0.02

;include !libs\debug\debug.asm  ;****** REMOVEME ******

lsize           dd 100
light_z         dd 100.0
sto dd   10.05
stox dd   20.10

nr_of_lines dd 0
xlin        dd 0
ylin        dd 0
bump_przes  dd 0

pszesSG     dd  0
pszesSG2    dd  0
asd         dd 30
asd1        dd 0

_1000       dd 1000.0
_3         dd 3.88
_torus_l   dd 0.25

_NEAR_CLIP      dd  1.009
_NEAR_CLIP1     dd  1.009
_NEAR_CLIP2     dd  1.800
_NEAR_CLIP4     dd  2.500
_NEAR_CLIP5     dd 12.500
new_shadediv    dd 9990.0
Code32  EndS
End







